#include<semaphore.h>
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>
#include <stdint.h>
#include <limits.h>
#include<fcntl.h> 
#include<unistd.h>
#include<string.h>
#include<sys/stat.h>
#include <sys/types.h>

int *fds;
int setSize=2;
int *readCounters;
sem_t *mutex;
sem_t *readerLocks;
sem_t x,y;
pthread_t tid;
pthread_t writerthreads[100],readerthreads[100];
int readercount = 0;

unsigned modulus( unsigned char *num, size_t size, unsigned divisor) {
  unsigned rem = 0;
  
 while(size>0)
 {
     rem+=num[size--]%divisor;
 }
  return rem%divisor;
}


int file_search(char *key, cahr *value, int index) {
    lseek(fds[index], 0, SEEK_SET);
    int offset = 0;
    char fkey[256];
    char fval[256];
    do {
        if( read(fds[index], fkey, sizeof(fkey)) < 0 )
            break; 
        if( read(fds[index], fval, sizeof(fval)) < 0 )
            break; 
        if( strcmp(fkey, key)==0 ) {
            memcpy(value, fval, sizeof(fval));
            return offset;
        }
        offset += sizeof(fkey) + sizeof(fval);
    } while (1);
    return -1;
}

void file_del( char *key)
{   
    int offset;
    int index=modulus(key,256,setSize);
    sem_wait(&mutex[index]);

    offset = file_search(key, value, index) 
    if(offset >= 0) {
        lseek(fds[index], offset, SEEK_SET);
        write(fds[index], 0, 256);
        write(fds[index], 0, 256);
    }
    
    sem_post(&mutex[index]);
    
}
int file_get(char *key, char *value)
{   
    /* Gets the value stored at offset */
    /* Does not depend on key argument */
    int found =0;
    int index = modulus(key,strlen(key),setSize);
    sem_wait(&readerLocks[index]);
    readCounters[index]+=1;
    if(readCounters[index]==1)
        sem_wait(&mutex[index]);
    sem_post(&readerLocks[index]);
    
    if(file_search(key, value, index)>=0) {
        found = 1;
    }
    
    sem_wait(&readerLocks[index]);
    readCounters[index]-=1;
    if(readCounters[index]==0)
    {
        sem_post(&mutex[index]);
    }
    sem_post(&readerLocks[index]);
    return found;
}

off_t file_put(char *key,char *value) {
     /*
        if found then ask the offset where it is present and if the value noy matches with the present value ,update the given line
        if not present then search for empty line and insert there!
     */
    unsigned int index=modulus(key,256,setSize);
    off_t position;
    //sem_wait(&mutex[index]);
    printf("[Write to File: %d]\n",index);
    char *line;
    char lin[514];
    char blankspace[513];
    memset(blankspace, 0, sizeof(blankspace));
    size_t len=0;
    FILE *fp=fdopen(fds[index],"rb+");
    while ((getline(&line, &len, fp)) != -1)
    {
        int temp =strlen(line);
        char *fkey=strtok(line,":"); 
        if(strcmp(key,fkey)==0)
        {
            fseek(fp,position,SEEK_SET);
            fwrite(blankspace,sizeof(blankspace),temp,fp);
            break;
        }
        position=ftell(fp);
    }
    
    snprintf(lin,sizeof(lin),"%s:%s\n",key,value);
    fwrite(lin,sizeof(lin),strlen(lin),fp);
   
   
    //sem_post(&mutex[index]);
    return position;
}
int storage_init()
{
    /*
        define the array of file descriptors  depending on the prefix 
        define the array of readCount as well as the semaphore (read x and write y) for the same
        PUT,DEL would use write lock 
        GET would use read lock
        each write should return the line number
    */
    fds=(int *)malloc(sizeof(int)*setSize);
    readCounters=(int *)malloc(sizeof(int)*setSize);
    readerLocks=(sem_t *)malloc(sizeof(sem_t)*setSize);
    mutex=(sem_t *)malloc(sizeof(sem_t)*setSize);
    int i=0;
    char fileName[setSize+20];
    for(i=0;i<setSize;i++)
    {
        snprintf(fileName,sizeof(fileName),"File%d.txt",i);
        fds[i]=open(fileName, O_CREAT|O_RDWR,S_IRWXU);
        if(fds[i]<0)
        {
            printf("\n[Unable to Open File%d.txt]\n",i);
        }
        sem_init(&readerLocks[i],0,1);
        sem_init(&mutex[i],0,1);
        readCounters[i]=0;
    }
    printf("%u",modulus("99",256,setSize));

    //offset = file_put("24", "value245");
    //offset = file_put("24", "value1");
   //file_put("23","update1");
   //file_put("24","update6969");
    //file_get(prevkey, value);   // Doesnot depend on key arg, returns key and value at offset 0
    //printf("(%s)", value);
    //file_del("29");
    //file_get("24",value);
   // printf("(%s)\n", value);
    //file_del("21");
    //printf("(%s)\n", value);

}
